SystemOrganization addCategory: #'DocumentLogic-Test'!
SystemOrganization addCategory: #'DocumentLogic-Core'!

Object subclass: #DocumentLogic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Core'!

!DocumentLogic methodsFor: 'controlling' stamp: 'HwaJong 10/7/2012 22:54'!
closeActionClose: closeAction actionAskUserIfHeWantsToSaveAsBeforeClosing: askSaveAs actionAskUserIfHeWantsToSaveBeforeClosing: askSave actionSaveToOldCamp: saveAction actionSaveToNewCamp: saveAsAction 
^[self hasUnsavedChange
	ifTrue: 
		[self hasSaveMedium
			ifTrue: 
				[|ret| 
				ret := askSave value.
				ret isNil ifTrue: [^self].
				ret
					ifTrue: 
						saveAction
					ifFalse:
						saveAsAction]
			ifFalse: 
				[askSaveAs value
					ifTrue: 
						saveAsAction]]] ensure: closeAction
! !

!DocumentLogic methodsFor: 'controlling' stamp: 'HwaJong 10/6/2012 18:53'!
loadActionLoad: loadBlock actionAskUserSaveAsOrDiscard: askSaveAsBlock actionAskUserSaveOrSaveAsOrDiscard: askSaveOrSaveAsBlock actionSaveAs: saveAs actionSave: save
^[self saveMediumIsObsolete
	ifTrue: [self shouldBeImplemented]
	ifFalse: [
		self hasUnsavedChange
			ifTrue: [self hasSaveMedium
				ifTrue: [|ret|
					ret := askSaveOrSaveAsBlock value.
					ret 
						ifNotNil: [
							ret
								ifTrue: save
								ifFalse: saveAs]]
			ifFalse: [askSaveAsBlock value
				ifTrue: saveAs]]]] ensure: loadBlock


! !

!DocumentLogic methodsFor: 'controlling' stamp: 'HwaJong 10/6/2012 09:10'!
saveActionSaveAs: aBlock1 actionSaveToLoadMedium: aBlock2
^self hasSaveMedium
	ifTrue: aBlock2
	ifFalse: aBlock1! !

!DocumentLogic methodsFor: 'controlling' stamp: 'HwaJong 10/6/2012 16:31'!
saveAs: aString confirmOverwrite: block1 overwriteOperations: block2 noOverwriteOperations: block3
aString 
	ifNil: 
		[^self].
(self needToOverwriteWhenSavingTo: aString)
	ifTrue:
		[(block1 value: aString)
			ifTrue: [^block2 value: aString]
			ifFalse: [^self]].
block3 value: aString.! !

DocumentLogic subclass: #MockDoc
	instanceVariableNames: 'hasUnsavedChange saveMedium'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

!MockDoc methodsFor: 'testing' stamp: 'HwaJong 10/8/2012 10:30'!
hasSaveMedium
^saveMedium areYouSaveMediumOf: self! !

!MockDoc methodsFor: 'testing' stamp: 'HwaJong 10/5/2012 14:38'!
hasUnsavedChange
^hasUnsavedChange! !

!MockDoc methodsFor: 'initialize-release' stamp: 'HwaJong 10/8/2012 10:28'!
initialize 
super initialize.
saveMedium := NoSaveMedium new.
hasUnsavedChange := false.
! !

!MockDoc methodsFor: 'actions' stamp: 'HwaJong 10/8/2012 10:29'!
load
saveMedium := FileSaveMedium.! !

!MockDoc methodsFor: 'actions' stamp: 'HwaJong 10/5/2012 14:38'!
modify
hasUnsavedChange := true.! !

!MockDoc methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 10:30'!
purgeSaveMedium
saveMedium := ObsoleteSaveMedium new.! !

!MockDoc methodsFor: 'actions' stamp: 'HwaJong 10/8/2012 15:56'!
saveAs: aString
saveMedium := saveMedium saveDocAs: aString.
hasUnsavedChange := false.! !

!MockDoc methodsFor: 'testing' stamp: 'HwaJong 10/8/2012 10:30'!
saveMediumIsObsolete
^saveMedium isObsolete! !

!MockDoc methodsFor: 'query' stamp: 'HwaJong 10/8/2012 15:50'!
whatAreYouGoingToDoWhenUserCloses
|actions|
actions := OrderedCollection new.
self 
	closeActionClose: [ actions addLast: #close ] 
	actionAskUserIfHeWantsToSaveAsBeforeClosing: [true]
	actionAskUserIfHeWantsToSaveBeforeClosing: [true] 
	actionSaveToOldCamp: [actions addLast: #saveAction] 
	actionSaveToNewCamp: [actions addLast: #saveAsAction].
^actions asArray.! !

!MockDoc methodsFor: 'query' stamp: 'HwaJong 10/8/2012 16:00'!
whatAreYouGoingToDoWhenUserLoads
|actions|
actions := OrderedCollection new.
self 
	loadActionLoad: [actions addLast: #load] 
	actionAskUserSaveAsOrDiscard: [true] 
	actionAskUserSaveOrSaveAsOrDiscard: [true] 
	actionSaveAs: [actions addLast: #saveAs] 
	actionSave: [actions addLast: #save].
^actions asArray.! !

!MockDoc methodsFor: 'query' stamp: 'HwaJong 10/8/2012 08:41'!
whatAreYouGoingToDoWhenUserSaves
^self 
	saveActionSaveAs: [#saveAs] 
	actionSaveToLoadMedium: [#saveToLoadMedium]! !

Object subclass: #MockSaveMedium
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

MockSaveMedium subclass: #FileSaveMedium
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

!FileSaveMedium classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 10:31'!
areYouSaveMediumOf: aMockDoc 
^true! !

!FileSaveMedium methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 10:32'!
areYouSaveMediumOf: aMockDoc 
^true! !

!FileSaveMedium methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:57'!
fileName: aByteString 
fileName:= aByteString 
! !

!FileSaveMedium methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 10:32'!
isObsolete
^false! !

MockSaveMedium subclass: #NoSaveMedium
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

!NoSaveMedium methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 10:31'!
areYouSaveMediumOf: aMockDoc 
^false! !

!NoSaveMedium methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 10:32'!
isObsolete
^false! !

!NoSaveMedium methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:57'!
saveDocAs: aByteString 
	^FileSaveMedium new
		fileName: aByteString! !

MockSaveMedium subclass: #ObsoleteSaveMedium
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

TestCase subclass: #DocTest
	instanceVariableNames: 'doc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

DocTest subclass: #DirtyLoadedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

!DirtyLoadedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:09'!
isAbstract 
^false! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:09'!
docShouldBeNew
^false! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:22'!
docShouldHaveSaveMedium
^true! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:44'!
docShouldHaveUnsavedChange
^true! !

!DirtyLoadedDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 18:09'!
setUp
super setUp.
doc load.
doc modify.! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:47'!
whatShouldDocDoWhenUserCloses
^#(saveAction close)! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:41'!
whatShouldDocDoWhenUserLoads
^#(save load)! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:12'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !

DocTest subclass: #DirtyNewDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

!DirtyNewDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:54'!
isAbstract
^false! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:55'!
docShouldBeNew
^true! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:22'!
docShouldHaveSaveMedium
^false! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:43'!
docShouldHaveUnsavedChange
^true! !

!DirtyNewDocTest methodsFor: 'running' stamp: 'HwaJong 10/8/2012 10:26'!
setUp
super setUp.
doc := MockDoc new.
doc modify.! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:48'!
whatShouldDocDoWhenUserCloses
^#(saveAsAction close)! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:42'!
whatShouldDocDoWhenUserLoads
^#(saveAs load)! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:02'!
whatShouldDocDoWhenUserSaves
^#saveAs! !

DocTest subclass: #DirtySavedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

!DirtySavedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:58'!
isAbstract
^false! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:01'!
docShouldBeNew
^false! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:23'!
docShouldHaveSaveMedium
^true! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:00'!
docShouldHaveUnsavedChange
^true! !

!DirtySavedDocTest methodsFor: 'running' stamp: 'HwaJong 10/8/2012 16:19'!
setUp
super setUp.
doc saveAs: 'unique name'.
doc modify.! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:49'!
whatShouldDocDoWhenUserCloses
^#(saveAction close)! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:42'!
whatShouldDocDoWhenUserLoads
^#(save load)! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:06'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !

!DocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:54'!
isAbstract
^true! !

!DocTest methodsFor: 'running' stamp: 'HwaJong 10/8/2012 10:26'!
setUp
super setUp.
doc := MockDoc new.! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/5/2012 14:21'!
testHasSaveMedium
self assert: doc hasSaveMedium equals: self docShouldHaveSaveMedium! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/5/2012 13:40'!
testHasUnsavedChange
self assert: doc hasUnsavedChange equals: self docShouldHaveUnsavedChange! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/5/2012 15:25'!
testWhatAreYouGoingToDoWhenUserCloses
self assert: doc whatAreYouGoingToDoWhenUserCloses equals: self whatShouldDocDoWhenUserCloses.! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/5/2012 15:25'!
testWhatAreYouGoingToDoWhenUserLoads
self assert: doc whatAreYouGoingToDoWhenUserLoads equals: self whatShouldDocDoWhenUserLoads.! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/5/2012 15:25'!
testWhatAreYouGoingToDoWhenUserSaves
self assert: doc whatAreYouGoingToDoWhenUserSaves equals: self whatShouldDocDoWhenUserSaves.! !

DocTest subclass: #LoadedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

!LoadedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:04'!
isAbstract
^false! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:05'!
docShouldBeNew
^false! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:23'!
docShouldHaveSaveMedium
^true! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:42'!
docShouldHaveUnsavedChange
^false! !

!LoadedDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 18:05'!
setUp
super setUp.
doc load.! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:49'!
whatShouldDocDoWhenUserCloses
^#(close)! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:43'!
whatShouldDocDoWhenUserLoads
^#(load)! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:07'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !

DocTest subclass: #NewDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

!NewDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:54'!
isAbstract
^false! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:55'!
docShouldBeNew
^true! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:23'!
docShouldHaveSaveMedium
^false! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:40'!
docShouldHaveUnsavedChange
^false! !

!NewDocTest methodsFor: 'running' stamp: 'HwaJong 10/8/2012 10:26'!
setUp
super setUp.
doc := MockDoc new.! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:50'!
whatShouldDocDoWhenUserCloses
^#(close)! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:43'!
whatShouldDocDoWhenUserLoads
^#(load)! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:02'!
whatShouldDocDoWhenUserSaves
^#saveAs! !

DocTest subclass: #SavedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic-Test'!

!SavedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:10'!
isAbstract
^false! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:11'!
docShouldBeNew
^false! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:24'!
docShouldHaveSaveMedium
^true! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:41'!
docShouldHaveUnsavedChange
^false! !

!SavedDocTest methodsFor: 'running' stamp: 'HwaJong 10/8/2012 16:20'!
setUp
super setUp.
doc saveAs: 'unique name'.! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:50'!
whatShouldDocDoWhenUserCloses
^#(close)! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/8/2012 15:43'!
whatShouldDocDoWhenUserLoads
^#(load)! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:14'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !
